// utilise le langage XML REPONSES de PAELLOS pour les données de CKEDITOR
CKEDITOR.plugins.add('reponses', {
    init: function(editor) {
        editor.dataProcessor = new myDataProcessor(editor);
    }
});

myDataProcessor = function(editor) {
    this.editor = editor;
    this.htmlDP = new CKEDITOR.htmlDataProcessor(editor);
    // ces filtres sont inutiles mais ckeditor plante sans...
    this.dataFilter = new CKEDITOR.htmlParser.filter();
    this.htmlFilter = new CKEDITOR.htmlParser.filter();
};

myDataProcessor.prototype = {
    toDataFormat : function(html_texte, fixForBody) {
        // HTML -> XML
        var html_dom, doc, racine;
        html_dom = document.createElement('div');
        // nettoyage initial avec htmlDataProcessor
        // (pour éviter des trucs comme <strong><ul><li><strong> ou <strong><p><strong>)
        // il reste encore des <strong><strong> après...
        html_texte = this.htmlDP.toHtml(html_texte, fixForBody);
        html_dom.innerHTML = html_texte;
        if (document.implementation && document.implementation.createDocument)
            doc = document.implementation.createDocument(null, 'REPONSES', null);
        else { // IE
            doc = new ActiveXObject("Microsoft.XMLDOM");
            racine = doc.createElement('REPONSES');
            doc.appendChild(racine);
        }
        doc.documentElement.appendChild(doc.createTextNode('\n'));
        this.HTMLversXML(html_dom, doc.documentElement, this.editor.config);
        return(this.XMLToString(doc));
    },
    
    toHtml : function(data, fixForBody) {
        var xmldoc, html_dom, html_dom_2, racine;
        if (data == '')
            return('');
        if (fixForBody === undefined) {
            // en fait il s'agit d'une transformation HTML -> HTML, utilisée par exemple lors d'un copier-coller
            // nettoyage initial avec htmlDataProcessor, puis filtre des éléments correspondants au langage XML
            data = this.htmlDP.toHtml(data, fixForBody);
            html_dom = document.createElement('div');
            html_dom.innerHTML = data;
            html_dom_2 = document.createElement('div');
            this.HTMLversHTML(html_dom, html_dom_2, this.editor.config);
            return(html_dom_2.innerHTML);
        } else { // valeurs possibles: false, 'p'
            // XML -> HTML
            racine = (data.charAt(0) == '<');
            if (!racine)
                data = '<REPONSES>' + data + '</REPONSES>';
            xmldoc = this.parseXML(data);
            html_dom = document.createElement('div');
            this.XMLversHTML(xmldoc.documentElement, html_dom, this.editor.config, null, null);
            return(html_dom.innerHTML);
        }
    },
    
    parseXML : function(txt) {
        if (window.DOMParser) {
            parser = new DOMParser();
            xmlDoc = parser.parseFromString(txt, 'text/xml');
        } else {
            // pour IE7 et IE8
            xmlDoc = new ActiveXObject('Microsoft.XMLDOM'); // ou 'MSXML.DomDocument' ?
            xmlDoc.preserveWhiteSpace = true; // sinon IE ignore les noeuds texte avec des retours à la ligne
            xmlDoc.async = false;
            xmlDoc.loadXML(txt);
        }
        return(xmlDoc);
    },
    
    XMLToString : function(n) {
        var sxml;
        try {
            sxml = (new XMLSerializer()).serializeToString(n);
        } catch (ex) {
            sxml = n.xml; // pour IE
        }
        if (sxml.substring(0, 2) != '<?')
            sxml = '<?xml version="1.0" encoding="UTF-8"?>' + sxml;
        return(sxml);
    },
    
    texteSimple : function(p) {
        var s, n;
        if (p.nodeType == 1) { // ELEMENT_NODE
            s = '';
            for (n = p.firstChild; n != null; n = n.nextSibling)
                s += this.texteSimple(n);
        } else if (p.nodeType == 3) // TEXT_NODE
            s = p.nodeValue;
        else
            s = '';
        return(s);
    },
    
    HTMLversXML : function(elt_html, parent_xml, config) {
        var serveur_equations, specialChars, n, nxml, src, nl, texte, ind;
        serveur_equations = config.serveur_equations;
        specialChars = config.specialChars;
        for (n = elt_html.firstChild; n != null; n = n.nextSibling) {
            if (n.nodeType == 1) { // ELEMENT_NODE
                if ((n.nodeName == 'B' || n.nodeName == 'STRONG') && n.firstChild != null) {
                    if (parent_xml.nodeName != 'GRAS') {
                        nxml = parent_xml.ownerDocument.createElement('GRAS');
                        parent_xml.appendChild(nxml);
                        this.HTMLversXML(n, nxml, config);
                    } else
                        this.HTMLversXML(n, parent_xml, config);
                } else if ((n.nodeName == 'I' || n.nodeName == 'EM') && n.firstChild != null) {
                    if (parent_xml.nodeName != 'ITALIQUE') {
                        nxml = parent_xml.ownerDocument.createElement('ITALIQUE');
                        parent_xml.appendChild(nxml);
                        this.HTMLversXML(n, nxml, config);
                    } else
                        this.HTMLversXML(n, parent_xml, config);
                } else if ((n.nodeName == 'SUP') && n.firstChild != null) {
                    if (parent_xml.nodeName != 'EXPOSANT') {
                        nxml = parent_xml.ownerDocument.createElement('EXPOSANT');
                        parent_xml.appendChild(nxml);
                        this.HTMLversXML(n, nxml, config);
                    } else
                        this.HTMLversXML(n, parent_xml, config);
                } else if ((n.nodeName == 'SUB') && n.firstChild != null) {
                    if (parent_xml.nodeName != 'INDICE') {
                        nxml = parent_xml.ownerDocument.createElement('INDICE');
                        parent_xml.appendChild(nxml);
                        this.HTMLversXML(n, nxml, config);
                    } else
                        this.HTMLversXML(n, parent_xml, config);
                } else if (n.nodeName == 'A') {
                    if (n.getAttribute('href') != null && n.getAttribute('href').indexOf('http://') == 0) {
                        nxml = parent_xml.ownerDocument.createElement('LIENWEB');
                        nxml.setAttribute('url', n.getAttribute('href'));
                        parent_xml.appendChild(nxml);
                        this.HTMLversXML(n, nxml, config);
                    } else
                        this.HTMLversXML(n, parent_xml, config);
                } else if (n.nodeName == 'UL') {
                    nxml = parent_xml.ownerDocument.createElement('LISTE');
                    nxml.appendChild(parent_xml.ownerDocument.createTextNode('\n'));
                    parent_xml.appendChild(nxml);
                    this.HTMLversXML(n, nxml, config);
                    nxml = parent_xml.ownerDocument.createTextNode('\n');
                    parent_xml.appendChild(nxml);
                } else if (n.nodeName == 'LI') {
                    nxml = parent_xml.ownerDocument.createElement('ITEM');
                    parent_xml.appendChild(nxml);
                    this.HTMLversXML(n, nxml, config);
                    nxml = parent_xml.ownerDocument.createTextNode('\n');
                    parent_xml.appendChild(nxml);
                } else if (n.nodeName == 'TABLE') {
                    nxml = parent_xml.ownerDocument.createElement('TABLEAU');
                    parent_xml.appendChild(nxml);
                    nl = n.getElementsByTagName('caption');
                    if (nl.length > 0 && nl[0].firstChild != null)
                        nxml.setAttribute('titre', this.texteSimple(nl[0]));
                    this.HTMLversXML(n, nxml, config);
                    nxml = parent_xml.ownerDocument.createTextNode('\n');
                    parent_xml.appendChild(nxml);
                } else if (n.nodeName == 'THEAD' || n.nodeName == 'TBODY') {
                    this.HTMLversXML(n, parent_xml, config);
                } else if (n.nodeName == 'TR') {
                    nxml = parent_xml.ownerDocument.createElement('TR');
                    parent_xml.appendChild(nxml);
                    this.HTMLversXML(n, nxml, config);
                    nxml = parent_xml.ownerDocument.createTextNode('\n');
                    parent_xml.appendChild(nxml);
                } else if (n.nodeName == 'TD' || n.nodeName == 'TH') {
                    nxml = parent_xml.ownerDocument.createElement(n.nodeName);
                    // remarque: tous les navigateurs ont un bug et renvoient null au lieu de ''
                    if (n.getAttribute('rowspan') != null && n.getAttribute('rowspan') != '' && n.getAttribute('rowspan') != '1')
                        nxml.setAttribute('rowspan', n.getAttribute('rowspan'));
                    if (n.getAttribute('colspan') != null && n.getAttribute('colspan') != '' && n.getAttribute('colspan') != '1')
                        nxml.setAttribute('colspan', n.getAttribute('colspan'));
                    if (n.getAttribute('align') != null && n.getAttribute('align') != '')
                        nxml.setAttribute('align', n.getAttribute('align'));
                    parent_xml.appendChild(nxml);
                    this.HTMLversXML(n, nxml, config);
                } else if (n.nodeName == 'IMG') {
                    nxml = parent_xml.ownerDocument.createElement('EQUATION');
                    src = n.getAttribute('src');
                    ind = src.indexOf('equation=');
                    if (ind == -1)
                        alert("Attention, l'insertion d'images n'est pas géré par cet éditeur");
                    else {
                        texte_eq = decodeURIComponent(src.substring(ind + 9));
                        nxml.setAttribute('texte', texte_eq);
                        if (parent_xml.nodeName == 'GRAS' || parent_xml.nodeName == 'ITALIQUE' ||
                                parent_xml.nodeName == 'EXPOSANT' || parent_xml.nodeName == 'INDICE') {
                            // à l'intérieur d'un style : on le coupe en 2 pour que l'équation soit à l'extérieur
                            // bug : ceci ne fonctionne que s'il n'y a qu'un seul style
                            if (n.previousSibling == null) {
                                parent_xml.parentNode.insertBefore(nxml, parent_xml);
                            } else {
                                parent_xml.parentNode.appendChild(nxml);
                                if (n.nextSibling != null) {
                                    nxml = parent_xml.ownerDocument.createElement(parent_xml.nodeName);
                                    parent_xml.parentNode.appendChild(nxml);
                                    parent_xml = nxml;
                                }
                            }
                        } else {
                            parent_xml.appendChild(nxml);
                        }
                    }
                } else if (n.nodeName == 'BR') {
                    if ((elt_html.nodeName != 'DIV' && elt_html.nodeName != 'P' && elt_html.nodeName != 'LI' &&
                            elt_html.nodeName != 'TD' && elt_html.nodeName != 'TH') ||
                            n.nextSibling != null) { // pas de saut en cas de br en fin de div p li td th
                        nxml = parent_xml.ownerDocument.createTextNode('\n');
                        parent_xml.appendChild(nxml);
                    }
                } else if (n.nodeName == 'DIV' || n.nodeName == 'P') {
                    this.HTMLversXML(n, parent_xml, config);
                    nxml = parent_xml.ownerDocument.createTextNode('\n');
                    parent_xml.appendChild(nxml);
                }
            } else if (n.nodeType == 3) { // TEXT_NODE
                texte = n.nodeValue.replace(/\n/g,'');
                this.ajout_noeud_texte_xml(parent_xml, texte, specialChars);
            }
        }
    },
    
    getWholeChar: function(str, i) { // pour les caractères unicode sur 4 octets, à utiliser à la place de charAt
        var code = str.charCodeAt(i);     
        
        if (isNaN(code)) {
            return ''; // Position not found
        }
        if (code < 0xD800 || code > 0xDFFF) {
            return str.charAt(i);
        }
        if (0xD800 <= code && code <= 0xDBFF) { // High surrogate (could change last hex to 0xDB7F to treat high private surrogates as single characters)
            if (str.length <= (i+1))  {
                throw 'High surrogate without following low surrogate';
            }
            var next = str.charCodeAt(i+1);
            if (0xDC00 > next || next > 0xDFFF) {
                throw 'High surrogate without following low surrogate';
            }
            return str.charAt(i)+str.charAt(i+1);
        }
        // Low surrogate (0xDC00 <= code && code <= 0xDFFF)
        if (i === 0) {
            throw 'Low surrogate without preceding high surrogate';
        }
        var prev = str.charCodeAt(i-1);
        if (0xD800 > prev || prev > 0xDBFF) { // (could change last hex to 0xDB7F to treat high private surrogates as single characters)
            throw 'Low surrogate without preceding high surrogate';
        }
        return false; // We can pass over low surrogates now as the second component in a pair which we have already processed
    },
    
    ajout_noeud_texte_xml : function(parent_xml, texte, specialChars) {
        // ajoute le texte sous le parent en remplaçant les caractères spéciaux par des éléments SYMBOLE
        var i, j, c, ind, s, nxml;
        s = '';
        for (i=0; i<texte.length; i++) {
            c = this.getWholeChar(texte, i);
            if (c === false)
                continue;
            if (Array.indexOf)
                ind = specialChars.indexOf(c);
            else { // pour IE...
                ind = -1;
                for (j=0; j<specialChars.length; j++) {
                    if (specialChars[j] == c) {
                        ind = j;
                        break;
                    }
                }
            }
            if (ind == -1) {
                s += c;
            } else {
                if (s != '') {
                    nxml = parent_xml.ownerDocument.createTextNode(s);
                    parent_xml.appendChild(nxml);
                    s = '';
                }
                nxml = parent_xml.ownerDocument.createElement('SYMBOLE');
                nxml.appendChild(parent_xml.ownerDocument.createTextNode(c));
                parent_xml.appendChild(nxml);
            }
        }
        if (s != '') {
            nxml = parent_xml.ownerDocument.createTextNode(s);
            parent_xml.appendChild(nxml);
        }
    },
    
    XMLversHTML : function(parent_xml, parent_html, config, p, item) {
        // p est le paragraphe courant
        // item est l'élément de liste ancêtre
        var n, name, nhtml, nhtml2, texte, parent_html_texte;
        parent_html_texte = parent_html; // sera parent du texte et des éléments mélangés au texte
        for (n = parent_xml.firstChild; n != null; n = n.nextSibling) {
            if (n.nodeType == 1) { // ELEMENT_NODE
                name = n.nodeName;
                if (name == 'GRAS' || name == 'ITALIQUE' || name == 'EXPOSANT' ||
                        name == 'INDICE' || name == 'LIENWEB' || name == 'SYMBOLE' || name == 'EQUATION') {
                    if (item != null) {
                        // dans un élément de liste on ne découpe pas en paragraphes
                        parent_html_texte = parent_html;
                    } else if (p == null) {
                        p = parent_html.ownerDocument.createElement('p');
                        parent_html.appendChild(p);
                        parent_html_texte = p;
                    }
                } else {
                    if (item == null && p != null) {
                        // sans le br, certains navigateurs ne sautent pas d'espace avec les paragraphes vides
                        if (p.firstChild == null)
                            p.appendChild(parent_html.ownerDocument.createElement('br'));
                        p = null;
                    }
                    parent_html_texte = null;
                }
                if (name == 'REPONSES') {
                    this.XMLversHTML(n, parent_html, config, null, null);
                } else if (name == 'REPONSE') {
                    if (n.getAttribute('numero') != null && n.getAttribute('numero') != '') {
                        nhtml = parent_html.ownerDocument.createElement('p');
                        nhtml.appendChild(parent_html.ownerDocument.createTextNode(n.getAttribute('numero') + ')'));
                        parent_html.appendChild(nhtml);
                    }
                    this.XMLversHTML(n, parent_html, config, null, null);
                } else if (name == 'GRAS') {
                    nhtml = parent_html.ownerDocument.createElement('strong');
                    parent_html_texte.appendChild(nhtml);
                    this.XMLversHTML(n, nhtml, config, p, item);
                } else if (name == 'ITALIQUE') {
                    nhtml = parent_html.ownerDocument.createElement('em');
                    parent_html_texte.appendChild(nhtml);
                    this.XMLversHTML(n, nhtml, config, p, item);
                } else if (name == 'EXPOSANT') {
                    nhtml = parent_html.ownerDocument.createElement('sup');
                    parent_html_texte.appendChild(nhtml);
                    this.XMLversHTML(n, nhtml, config, p, item);
                } else if (name == 'INDICE') {
                    nhtml = parent_html.ownerDocument.createElement('sub');
                    parent_html_texte.appendChild(nhtml);
                    this.XMLversHTML(n, nhtml, config, p, item);
                } else if (name == 'LIENWEB') {
                    nhtml = parent_html.ownerDocument.createElement('a');
                    nhtml.setAttribute('href', n.getAttribute('url'));
                    parent_html_texte.appendChild(nhtml);
                    this.XMLversHTML(n, nhtml, config, p, item);
                } else if (name == 'SYMBOLE') {
                    if (n.firstChild != null)
                        texte = n.firstChild.nodeValue;
                    else // dans l'ancienne version de REPONSES, un attribut nom était utilisé au lieu du texte
                        texte = '?';
                    parent_html_texte.appendChild(parent_html.ownerDocument.createTextNode(texte));
                } else if (name == 'EQUATION') {
                    nhtml = parent_html.ownerDocument.createElement('img');
                    nhtml.setAttribute('src', config.serveur_equations + encodeURIComponent(n.getAttribute('texte')));
                    nhtml.className = 'equation';
                    parent_html_texte.appendChild(nhtml);
                    this.XMLversHTML(n, nhtml, config, p, item);
                } else if (name == 'LISTE') {
                    nhtml = parent_html.ownerDocument.createElement('ul');
                    parent_html.appendChild(nhtml);
                    this.XMLversHTML(n, nhtml, config, null, null);
                } else if (name == 'ITEM') {
                    nhtml = parent_html.ownerDocument.createElement('li');
                    parent_html.appendChild(nhtml);
                    this.XMLversHTML(n, nhtml, config, null, nhtml);
                } else if (name == 'TABLEAU') {
                    nhtml = parent_html.ownerDocument.createElement('table');
                    nhtml.setAttribute('border', '1');
                    nhtml.setAttribute('cellpadding', '4');
                    nhtml.setAttribute('cellspacing', '0');
                    parent_html.appendChild(nhtml);
                    if (n.getAttribute('titre') != null && n.getAttribute('titre') != '') {
                        nhtml2 = parent_html.ownerDocument.createElement('caption');
                        nhtml2.appendChild(parent_html.ownerDocument.createTextNode(n.getAttribute('titre')));
                        nhtml.appendChild(nhtml2);
                    }
                    this.XMLversHTML(n, nhtml, config, null, null);
                } else if (name == 'TR') {
                    nhtml = parent_html.ownerDocument.createElement('tr');
                    parent_html.appendChild(nhtml);
                    this.XMLversHTML(n, nhtml, config, null, null);
                } else if (name == 'TD' || name == 'TH') {
                    nhtml = parent_html.ownerDocument.createElement(name);
                    if (n.getAttribute('rowspan') != null && n.getAttribute('rowspan') != '' && n.getAttribute('rowspan') != '1')
                        nhtml.setAttribute('rowspan', n.getAttribute('rowspan'));
                    if (n.getAttribute('colspan') != null && n.getAttribute('colspan') != '' && n.getAttribute('colspan') != '1')
                        nhtml.setAttribute('colspan', n.getAttribute('colspan'));
                    if (n.getAttribute('align') != null && n.getAttribute('align') != '')
                        nhtml.setAttribute('align', n.getAttribute('align'));
                    parent_html.appendChild(nhtml);
                    this.XMLversHTML(n, nhtml, config, null, null);
                }
            } else if (n.nodeType == 3) { // TEXT_NODE
                // découpage en P ou BR en fonction du parent
                if (parent_xml.nodeName == 'REPONSES' || parent_xml.nodeName == 'REPONSE' ||
                        parent_xml.nodeName == 'TD' || parent_xml.nodeName == 'TH') {
                    texte = n.nodeValue;
                    // on retire le retour à la ligne après une fin de liste ou de tableau
                    // (qui était juste là pour faire joli mais ne représente pas un saut de ligne)
                    if (n.previousSibling != null && (n.previousSibling.nodeName == 'LISTE' ||
                            n.previousSibling.nodeName == 'TABLEAU') && texte.indexOf('\n') == 0)
                        texte = texte.substring(1);
                    // idem pour le premier \n sous REPONSES et REPONSE
                    else if ((parent_xml.nodeName == 'REPONSES' || parent_xml.nodeName == 'REPONSE') &&
                            n.previousSibling == null && texte.indexOf('\n') == 0)
                        texte = texte.substring(1);
                    p = this.ajout_paragraphes(parent_html, p, texte);
                    parent_html_texte = p;
                } else if (item != null) {
                    texte = n.nodeValue;
                    if (n.previousSibling != null && (n.previousSibling.nodeName == 'LISTE' ||
                            n.previousSibling.nodeName == 'TABLEAU') && texte.indexOf('\n') == 0)
                        texte = texte.substring(1);
                    this.ajout_br(parent_html, texte);
                } else {
                    parent_html.appendChild(parent_html.ownerDocument.createTextNode(n.nodeValue));
                }
            }
        }
    },
    
    ajout_br : function(parent_html, texte) {
        // ajoute le texte sous le parent en ajoutant des BR avant chaque retour à la ligne
        var i, c, s, nhtml;
        s = '';
        for (i=0; i<texte.length; i++) {
            c = texte.charAt(i);
            s += c;
            if (c == '\n') {
                if (s != '') {
                    nhtml = parent_html.ownerDocument.createTextNode(s);
                    parent_html.appendChild(nhtml);
                    s = '';
                }
                nhtml = parent_html.ownerDocument.createElement('br');
                parent_html.appendChild(nhtml);
            }
        }
        if (s != '') {
            nhtml = parent_html.ownerDocument.createTextNode(s);
            parent_html.appendChild(nhtml);
        }
    },
    
    ajout_paragraphes : function(parent_html, p, texte) {
        // ajoute le texte au paragraphe, en en créant de nouveaux à chaque \n ou si p est null
        // renvoie le dernier paragraphe utilisé
        var s, ind;
        s = texte;
        while (s != '') {
            if (p == null) {
                p = parent_html.ownerDocument.createElement('p');
                parent_html.appendChild(p);
            }
            ind = s.indexOf('\n');
            if (ind == -1) {
                p.appendChild(parent_html.ownerDocument.createTextNode(s));
                s = '';
            } else {
                if (ind != 0)
                    p.appendChild(parent_html.ownerDocument.createTextNode(s.substring(0, ind)));
                
                if (p.firstChild == null)
                    p.appendChild(parent_html.ownerDocument.createElement('br'));
                
                p = null;
                s = s.substring(ind + 1);
            }
        }
        return(p);
    },
    
    HTMLversHTML : function(elt_html, parent_html, config) {
        // nettoyage intégral mais préservant le texte
        var serveur_equations, specialChars, n, nhtml, nl, texte;
        serveur_equations = config.serveur_equations;
        specialChars = config.specialChars;
        for (n = elt_html.firstChild; n != null; n = n.nextSibling) {
            if (n.nodeType == 1) { // ELEMENT_NODE
                if ((n.nodeName == 'B' || n.nodeName == 'STRONG') && n.firstChild != null) {
                    nhtml = parent_html.ownerDocument.createElement('STRONG');
                    parent_html.appendChild(nhtml);
                    this.HTMLversHTML(n, nhtml, config);
                } else if ((n.nodeName == 'I' || n.nodeName == 'EM') && n.firstChild != null) {
                    nhtml = parent_html.ownerDocument.createElement('EM');
                    parent_html.appendChild(nhtml);
                    this.HTMLversHTML(n, nhtml, config);
                } else if ((n.nodeName == 'SUP') && n.firstChild != null) {
                    nhtml = parent_html.ownerDocument.createElement(n.nodeName);
                    parent_html.appendChild(nhtml);
                    this.HTMLversHTML(n, nhtml, config);
                } else if ((n.nodeName == 'SUB') && n.firstChild != null) {
                    nhtml = parent_html.ownerDocument.createElement(n.nodeName);
                    parent_html.appendChild(nhtml);
                    this.HTMLversHTML(n, nhtml, config);
                } else if (n.nodeName == 'A') {
                    if (n.getAttribute('href') != null && n.getAttribute('href').indexOf('http://') == 0) {
                        nhtml = parent_html.ownerDocument.createElement(n.nodeName);
                        nhtml.setAttribute('href', n.getAttribute('href'));
                        parent_html.appendChild(nhtml);
                        this.HTMLversHTML(n, nhtml, config);
                    } else
                        this.HTMLversHTML(n, parent_html, config);
                } else if (n.nodeName == 'UL' || n.nodeName == 'LI') {
                    nhtml = parent_html.ownerDocument.createElement(n.nodeName);
                    parent_html.appendChild(nhtml);
                    this.HTMLversHTML(n, nhtml, config);
                } else if (n.nodeName == 'TABLE') {
                    nhtml = parent_html.ownerDocument.createElement(n.nodeName);
                    nhtml.setAttribute('border', '1');
                    nhtml.setAttribute('cellpadding', '4');
                    nhtml.setAttribute('cellspacing', '0');
                    parent_html.appendChild(nhtml);
                    this.HTMLversHTML(n, nhtml, config);
                } else if (n.nodeName == 'CAPTION') {
                    nhtml = parent_html.ownerDocument.createElement(n.nodeName);
                    nhtml.appendChild(parent_html.ownerDocument.createTextNode(this.texteSimple(n)));
                    parent_html.appendChild(nhtml);
                } else if (n.nodeName == 'THEAD' || n.nodeName == 'TBODY' || n.nodeName == 'TR') {
                    nhtml = parent_html.ownerDocument.createElement(n.nodeName);
                    parent_html.appendChild(nhtml);
                    this.HTMLversHTML(n, nhtml, config);
                } else if (n.nodeName == 'TD' || n.nodeName == 'TH') {
                    nhtml = parent_html.ownerDocument.createElement(n.nodeName);
                    if (n.getAttribute('rowspan') != null && n.getAttribute('rowspan') != '' && n.getAttribute('rowspan') != '1')
                        nhtml.setAttribute('rowspan', n.getAttribute('rowspan'));
                    if (n.getAttribute('colspan') != null && n.getAttribute('colspan') != '' && n.getAttribute('colspan') != '1')
                        nhtml.setAttribute('colspan', n.getAttribute('colspan'));
                    if (n.getAttribute('align') != null && n.getAttribute('align') != '')
                        nhtml.setAttribute('align', n.getAttribute('align'));
                    parent_html.appendChild(nhtml);
                    this.HTMLversHTML(n, nhtml, config);
                } else if (n.nodeName == 'IMG') {
                    src = n.getAttribute('src');
                    ind = src.indexOf('equation=');
                    if (ind == -1)
                        alert("Attention, l'insertion d'images n'est pas géré par cet éditeur");
                    else {
                        nhtml = parent_html.ownerDocument.createElement('img');
                        nhtml.setAttribute('src', serveur_equations + src.substring(ind + 9));
                        nhtml.className = 'equation';
                        parent_html.appendChild(nhtml);
                    }
                } else if (n.nodeName == 'BR') {
                    nhtml = parent_html.ownerDocument.createElement(n.nodeName);
                    parent_html.appendChild(nhtml);
                } else if (n.nodeName == 'DIV' || n.nodeName == 'P') {
                    nhtml = parent_html.ownerDocument.createElement(n.nodeName);
                    parent_html.appendChild(nhtml);
                    this.HTMLversHTML(n, nhtml, config);
                } else if (n.nodeName == 'STYLE') {
                    // on ignore complètement cet élément et son contenu
                } else {
                    if (n.firstChild != null)
                        this.HTMLversHTML(n, parent_html, config);
                }
            } else if (n.nodeType == 3) { // TEXT_NODE
                nhtml = parent_html.ownerDocument.createTextNode(n.nodeValue);
                parent_html.appendChild(nhtml);
            }
        }
    }
   
}

