<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" extension-element-prefixes="urlencoder" xmlns:urlencoder="xalan://java.net.URLEncoder">
<xsl:output method="html" indent="no" encoding="US-ASCII"/>

<!-- ceci est du HTML destiné à être envoyé dans un mail -->
<xsl:template match="REPONSES">
    <html><xsl:text>
</xsl:text>
        <head>
            <!-- le CSS est dans les éléments à cause de certains clients mails -->
        </head><xsl:text>
</xsl:text>
        <body>
            <xsl:apply-templates/>
        </body><xsl:text>
</xsl:text>
    </html>
</xsl:template>

<xsl:template match="REPONSE">
    <div style="margin-left: 30px; margin-bottom: 1em; background-color: #FFFFEE;">
        <b><xsl:choose>
            <xsl:when test="@numero!=''"><xsl:value-of select="@numero"/>)</xsl:when>
            <xsl:otherwise>Réponse</xsl:otherwise>
        </xsl:choose></b><xsl:text> </xsl:text>
        <xsl:apply-templates/>
    </div>
</xsl:template>

<xsl:template match="LISTE">
    <ul>
        <xsl:apply-templates/>
    </ul>
</xsl:template>

<xsl:template match="ITEM">
    <li><xsl:apply-templates/></li>
</xsl:template>

<xsl:template match="TABLEAU">
    <table border="1" cellspacing="0" cellpadding="2">
        <xsl:if test="@titre!=''">
            <caption><xsl:value-of select="@titre"/></caption>
        </xsl:if>
        <xsl:apply-templates/>
    </table>
</xsl:template>

<xsl:template match="TR">
    <tr>
        <xsl:apply-templates/>
    </tr>
</xsl:template>

<xsl:template match="TH">
    <th>
        <xsl:if test="@colspan"><xsl:attribute name="colspan"><xsl:value-of select="@colspan"/></xsl:attribute></xsl:if>
        <xsl:if test="@rowspan"><xsl:attribute name="rowspan"><xsl:value-of select="@rowspan"/></xsl:attribute></xsl:if>
        <xsl:if test="@align"><xsl:attribute name="align"><xsl:value-of select="@align"/></xsl:attribute></xsl:if>
        <xsl:apply-templates/>
    </th>
</xsl:template>

<xsl:template match="TD">
    <td>
        <xsl:if test="@colspan"><xsl:attribute name="colspan"><xsl:value-of select="@colspan"/></xsl:attribute></xsl:if>
        <xsl:if test="@rowspan"><xsl:attribute name="rowspan"><xsl:value-of select="@rowspan"/></xsl:attribute></xsl:if>
        <xsl:if test="@align"><xsl:attribute name="align"><xsl:value-of select="@align"/></xsl:attribute></xsl:if>
        <xsl:apply-templates/>
    </td>
</xsl:template>

<xsl:template match="LIENWEB">
    <a href="{@url}"><xsl:apply-templates/></a>
</xsl:template>

<xsl:template match="SYMBOLE">
    <xsl:choose>
        <xsl:when test="@cid!=''"><img src="cid:{@cid}" alt="{.}" style="vertical-align: middle;"/></xsl:when>
        <xsl:otherwise><span class="symbole"><xsl:value-of select="."/></span></xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="EQUATION">
    <xsl:variable name="src"><xsl:choose>
        <xsl:when test="@cid!=''">cid:<xsl:value-of select="@cid"/></xsl:when>
        <xsl:otherwise>CetteServlet?equation=<xsl:call-template name="url-encode">
            <xsl:with-param name="str" select="@texte"/>
        </xsl:call-template></xsl:otherwise>
    </xsl:choose></xsl:variable>
    <img src="{$src}" alt="{@texte}" style="vertical-align: middle;"/>
</xsl:template>

<xsl:template match="GRAS">
    <b><xsl:apply-templates/></b>
</xsl:template>

<xsl:template match="ITALIQUE">
    <i><xsl:apply-templates/></i>
</xsl:template>

<xsl:template match="EXPOSANT">
    <sup><xsl:apply-templates/></sup>
</xsl:template>

<xsl:template match="INDICE">
    <sub><xsl:apply-templates/></sub>
</xsl:template>

<xsl:template match="text()">
    <xsl:if test="not(parent::LISTE or parent::TABLEAU or parent::TR)"><xsl:call-template name="sauts-de-ligne"/></xsl:if>
</xsl:template>

<xsl:template name="sauts-de-ligne">
    <xsl:param name="texte" select="."/>
    <xsl:choose>
        <xsl:when test="contains($texte, '&#xa;')">
            <xsl:value-of select="substring-before($texte, '&#xa;')"/><br/><xsl:text>
</xsl:text>
            <xsl:call-template name="sauts-de-ligne">
                <xsl:with-param name="texte" select="substring-after($texte, '&#xa;')"/>
            </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
            <xsl:value-of select="$texte"/>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template name="nom-fichier">
<!-- renvoit le nom d'un fichier à partir du chemin-->
    <xsl:param name="chemin"/>
    <xsl:param name="sep">/</xsl:param>
    <xsl:choose>
        <xsl:when test="contains($chemin, $sep)">
            <xsl:call-template name="nom-fichier"><xsl:with-param name="chemin" select="substring-after($chemin, $sep)"/></xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
            <xsl:value-of select="$chemin"/>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>


<xsl:template name="url-encode">
    <!-- encodage en UTF-8, le Connector Tomcat doit avoir URIEncoding="UTF-8" -->
    <xsl:param name="str"/>   
    <xsl:if test="$str">
        <xsl:choose>
            <xsl:when test="function-available('urlencoder:encode')">
                <xsl:value-of select="urlencoder:encode(string($str), string('UTF-8'))"/>
            </xsl:when>
            <xsl:otherwise>
                erreur
            </xsl:otherwise>
        </xsl:choose>
    </xsl:if>
</xsl:template>

</xsl:stylesheet>
