/*
PAELLOS - Plateforme d'Apprentissage En Ligne Libre Orientée Sémantique

Copyright (C) 2011 Observatoire de Paris

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformément aux dispositions de la Licence Publique Générale GNU, telle que publiée par la Free Software Foundation ; version 2 de la licence, ou encore (à votre choix) toute version ultérieure.

Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans même la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de détail, voir la Licence Publique Générale GNU .

Vous devez avoir reçu un exemplaire de la Licence Publique Générale GNU en même temps que ce programme ; si ce n'est pas le cas, écrivez à la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package paellos.base;

import paellos.jdb.Record;

public class Connection implements Record, Comparable<Connection> {
    public String numero;
    public String numuser;
    public String debut;
    public String fin;
    
    public Connection(final String numero, final String numuser, final String debut, final String fin) {
        this.numero = numero;
        this.numuser = numuser;
        this.debut = debut;
        this.fin = fin;
    }
    
    public Connection(final Object[] values) {
        if (values[0] != null)
            this.numero = values[0].toString();
        if (values[1] != null)
            this.numuser = values[1].toString();
        if (values[2] != null)
            this.debut = values[2].toString();
        if (values[3] != null)
            this.fin = values[3].toString();
    }
    
    public int compareTo(Connection conn) {
        return(numero.compareTo(conn.numero));
    }
    
    public Object[] getFieldValues() {
        final Object[] v = new Object[4];
        v[0] = numero;
        v[1] = numuser;
        v[2] = debut;
        v[3] = fin;
        return(v);
    }

    public Object getKeyValue() {
        return(numero);
    }
}
