/*
PAELLOS - Plateforme d'Apprentissage En Ligne Libre Orientée Sémantique

Copyright (C) 2011 Observatoire de Paris

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformément aux dispositions de la Licence Publique Générale GNU, telle que publiée par la Free Software Foundation ; version 2 de la licence, ou encore (à votre choix) toute version ultérieure.

Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans même la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de détail, voir la Licence Publique Générale GNU .

Vous devez avoir reçu un exemplaire de la Licence Publique Générale GNU en même temps que ce programme ; si ce n'est pas le cas, écrivez à la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package paellos.base;

import paellos.jdb.Record;

public class Coord implements Record, Comparable<Coord> {
    public String numero;
    public String numuser;
    public String rue1;
    public String rue2;
    public String codepostal;
    public String ville;
    public String pays;
    public String telephone;
    public String connection;
    public String acces;
    
    public Coord() {
        numero = null;
        numuser = null;
        rue1 = null;
        rue2 = null;
        codepostal = null;
        ville = null;
        pays = null;
        telephone = null;
        connection = null;
        acces = null;
    }
    
    public Coord(final String numuser) {
        numero = null;
        this.numuser = numuser;
        rue1 = null;
        rue2 = null;
        codepostal = null;
        ville = null;
        pays = null;
        telephone = null;
        connection = null;
        acces = null;
    }
    
    public Coord(final String numuser, final String rue1, final String rue2, final String codepostal,
            final String ville, final String pays, final String telephone, final String connection, final String acces) {
        this.numero = null;
        this.numuser = numuser;
        this.rue1 = rue1;
        this.rue2 = rue2;
        this.codepostal = codepostal;
        this.ville = ville;
        this.pays = pays;
        this.telephone = telephone;
        this.connection = null;
        this.acces = null;
    }
    
    public Coord(final Object[] values) {
        if (values[0] != null)
            numero = values[0].toString();
        if (values[1] != null)
            numuser = values[1].toString();
        if (values[2] != null)
            rue1 = values[2].toString();
        if (values[3] != null)
            rue2 = values[3].toString();
        if (values[4] != null)
            codepostal = values[4].toString();
        if (values[5] != null)
            ville = values[5].toString();
        if (values[6] != null)
            pays = values[6].toString();
        if (values[7] != null)
            telephone = values[7].toString();
        if (values[8] != null)
            connection = values[8].toString();
        if (values[9] != null)
            acces = values[9].toString();
    }
    
    public int compareTo(Coord coord) {
        return(numero.compareTo(coord.numero));
    }
    
    public Object[] getFieldValues() {
        final Object[] v = new Object[10];
        v[0] = numero;
        v[1] = numuser;
        v[2] = rue1;
        v[3] = rue2;
        v[4] = codepostal;
        v[5] = ville;
        v[6] = pays;
        v[7] = telephone;
        v[8] = connection;
        v[9] = acces;
        return(v);
    }

    public Object getKeyValue() {
        return(numero);
    }
}
