/*
PAELLOS - Plateforme d'Apprentissage En Ligne Libre Orientée Sémantique

Copyright (C) 2011 Observatoire de Paris

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformément aux dispositions de la Licence Publique Générale GNU, telle que publiée par la Free Software Foundation ; version 2 de la licence, ou encore (à votre choix) toute version ultérieure.

Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans même la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de détail, voir la Licence Publique Générale GNU .

Vous devez avoir reçu un exemplaire de la Licence Publique Générale GNU en même temps que ce programme ; si ce n'est pas le cas, écrivez à la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package paellos.base;

import java.util.Vector;

import paellos.jdb.*;

public class CoordDB extends JDB<Coord> {
    protected static String tableName = "coordonnees";
    public static String[] fields = {"numero", "numuser", "rue1", "rue2", "codepostal", "ville", "pays",
        "telephone", "connection", "acces"};
    protected static String keyField = "numero";
    protected static String createSQL =
        "create table coordonnees (numero INT NOT NULL AUTO_INCREMENT, numuser INT, rue1 VARCHAR(100), " +
        "rue2 VARCHAR(100), codepostal INT, ville VARCHAR(50), pays VARCHAR(30), " +
        "telephone VARCHAR(20), connection VARCHAR(30), acces VARCHAR(30), PRIMARY KEY (numero)) DEFAULT CHARSET=UTF8;";
    
    public CoordDB(final String userDBURL, final String userDBUSER, final String userDBPASSWORD) {
        init(userDBURL, userDBUSER, userDBPASSWORD, tableName, fields, keyField, createSQL);
    }
    
    public Coord newRecord(final Object[] values) {
        return(new Coord(values));
    }
    
    public void addCoord(final Coord coord) throws JDBException {
        addRecord(coord);
    }
    
    public void modCoord(final Coord coord) throws JDBException {
        modRecord(coord);
    }
    
    public void delCoord(final Coord coord) throws JDBException {
        delRecord(coord);
    }
    
    public Coord getCoord(final String numero) throws JDBException {
        return(getRecord(numero));
    }
    
    public Vector<Coord> getAllCoords() throws JDBException {
        return(getAllRecords());
    }
    
    public Vector<Coord> findCoords(final Coord coord) throws JDBException {
        return(findRecords(coord));
    }
    
}
