/*
PAELLOS - Plateforme d'Apprentissage En Ligne Libre Orientée Sémantique

Copyright (C) 2011 Observatoire de Paris

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformément aux dispositions de la Licence Publique Générale GNU, telle que publiée par la Free Software Foundation ; version 2 de la licence, ou encore (à votre choix) toute version ultérieure.

Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans même la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de détail, voir la Licence Publique Générale GNU .

Vous devez avoir reçu un exemplaire de la Licence Publique Générale GNU en même temps que ce programme ; si ce n'est pas le cas, écrivez à la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package paellos.base;

import java.sql.Blob;

import paellos.jdb.Record;

public class Exercice implements Record, Comparable<Exercice> {
    public String numero;
    public String numuser;
    public String chemin;
    public String date;
    public String titre;
    public String reponse;
    public String nomimage;
    public Blob image;
    public String note;
    public String datereponsetuteur;
    public String reponsetuteur;
    public String nomimagetuteur;
    public Blob imagetuteur;
    
    public Exercice() {
        numero = null;
        numuser = null;
        chemin = null;
        date = null;
        titre = null;
        reponse = null;
        nomimage = null;
        image = null;
        note = null;
        datereponsetuteur = null;
        reponsetuteur = null;
        nomimagetuteur = null;
        imagetuteur = null;
    }
    
    public Exercice(final String numuser) {
        numero = null;
        this.numuser = numuser;
        chemin = null;
        date = null;
        titre = null;
        reponse = null;
        nomimage = null;
        image = null;
        note = null;
        datereponsetuteur = null;
        reponsetuteur = null;
        nomimagetuteur = null;
        imagetuteur = null;
    }
    
    public Exercice(final Object[] values) {
        if (values[0] != null)
            this.numero = values[0].toString();
        if (values[1] != null)
            this.numuser = values[1].toString();
        if (values[2] != null)
            this.chemin = values[2].toString();
        if (values[3] != null)
            this.date = values[3].toString();
        if (values[4] != null)
            this.titre = values[4].toString();
        if (values[5] != null)
            this.reponse = values[5].toString();
        if (values[6] != null)
            this.nomimage = values[6].toString();
        if (values[7] != null)
            this.image = (Blob)values[7];
        if (values[8] != null)
            this.note = values[8].toString();
        if (values.length > 9) {
            if (values[9] != null)
                this.datereponsetuteur = values[9].toString();
            if (values[10] != null)
                this.reponsetuteur = values[10].toString();
            if (values[11] != null)
                this.nomimagetuteur = values[11].toString();
            if (values[12] != null)
                this.imagetuteur = (Blob)values[12];
        }
    }
    
    public int compareTo(Exercice exo) {
        return(chemin.compareTo(exo.chemin));
    }
    
    public Object[] getFieldValues() {
        final Object[] v = new Object[13];
        v[0] = numero;
        v[1] = numuser;
        v[2] = chemin;
        v[3] = date;
        v[4] = titre;
        v[5] = reponse;
        v[6] = nomimage;
        v[7] = image;
        v[8] = note;
        v[9] = datereponsetuteur;
        v[10] = reponsetuteur;
        v[11] = nomimagetuteur;
        v[12] = imagetuteur;
        return(v);
    }

    public Object getKeyValue() {
        return(numero);
    }
}
