/*
PAELLOS - Plateforme d'Apprentissage En Ligne Libre Orientée Sémantique

Copyright (C) 2011 Observatoire de Paris

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier conformément aux dispositions de la Licence Publique Générale GNU, telle que publiée par la Free Software Foundation ; version 2 de la licence, ou encore (à votre choix) toute version ultérieure.

Ce programme est distribué dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ; sans même la garantie implicite de COMMERCIALISATION ou D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de détail, voir la Licence Publique Générale GNU .

Vous devez avoir reçu un exemplaire de la Licence Publique Générale GNU en même temps que ce programme ; si ce n'est pas le cas, écrivez à la Free Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.
*/

package paellos.base;

import paellos.jdb.Record;

public class Lecture implements Record, Comparable<Lecture> {
    public String numero;
    public String alu;
    public String numconnection;
    
    public Lecture(final String numero, final String alu, final String numconnection) {
        this.numero = numero;
        this.alu = alu;
        this.numconnection = numconnection;
    }
    
    public Lecture(final Object[] values) {
        if (values[0] != null)
            this.numero = values[0].toString();
        if (values[1] != null)
            this.alu = values[1].toString();
        if (values[2] != null)
            this.numconnection = values[2].toString();
    }
    
    public int compareTo(Lecture lect) {
        return(alu.compareTo(lect.alu));
    }
    
    public Object[] getFieldValues() {
        final Object[] v = new Object[3];
        v[0] = numero;
        v[1] = alu;
        v[2] = numconnection;
        return(v);
    }

    public Object getKeyValue() {
        return(numero);
    }
}
